{ Program to read in one simplicial complex in GAP output format from standard
  input and compute its homology.

  Copyright 1997-2001 by Frank Heckenbach <heckenb@mi.uni-erlangen.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, version 2.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. }

{$gnu-pascal,I+}

program Homology_GAP;

uses GPC, Commentator_Pas, Tools, Simplicial, Comp_Hom;

const
  NumIntArgs  = 7;
  NumArgs = 10;

var
  r, c: Integer;
  Args: array [1 .. NumIntArgs] of Integer;
  Facets: TFaces;
  ErrMsg: TString;

begin
   ErrMsg := '';
   if ParamCount <> NumArgs then ErrMsg := 'Wrong number of command-line arguments';
   for c := 1 to NumIntArgs do
     if ErrMsg = '' then
       begin
         Val (ParamStr (c), Args [c], r);
         if r <> 0 then ErrMsg := 'Command-line argument is not an integer'
       end;
   Commentator := InitializeCommentator (Args [4], Args [3]);
   if ErrMsg <> '' then Abort (ErrMsg);
   Assign (ComplexFile, '');
   Reset (ComplexFile);
   if ReadChar <> Ch_Start_Compl2 then Abort ('Beginning of complex not found.');
   ReadComplex (Facets);
   if Args [6] = hmMatrixFile then
     ComputeBoundaryMapFile (Commentator, Facets, Args [1], ParamStr (10))
   else if Args [6] = hmMatrix then
     ComputeBoundaryMap (Commentator, Facets, Args [1], Args [2] )
   else
     ComputeHomology (Commentator, Facets, Args [1], Args [2], Args [5], Args [6], Args [7], ParamStr (8), ParamStr (9));
   DisposeFaces (Facets)
end.
